.TH file 3 "kernel  2.13.3" "Ericsson AB" "ERLANG MODULE DEFINITION"
.SH MODULE
file \- File Interface Module
.SH DESCRIPTION
.LP
The module \fIfile\fR provides an interface to the file system\&.
.LP
On operating systems with thread support, it is possible to let file operations be performed in threads of their own, allowing other Erlang processes to continue executing in parallel with the file operations\&. See the command line flag \fI+A\fR in erl(1)\&.

.SH DATA TYPES

.nf
iodata() = iolist() | binary()
  iolist() = [char() | binary() | iolist()]

io_device()
  as returned by file:open/2, a process handling IO protocols

name() = string() | atom() | DeepList
  DeepList = [char() | atom() | DeepList]

posix()
  an atom which is named from the Posix error codes used in
  Unix, and in the runtime libraries of most C compilers

ext_posix() = posix() | badarg

time() = {{Year, Month, Day}, {Hour, Minute, Second}}
  Year = Month = Day = Hour = Minute = Second = int()
  Must denote a valid date and time
.fi
.SH EXPORTS
.LP
.B
change_group(Filename, Gid) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Gid = int()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Changes group of a file\&. See write_file_info/2\&.
.RE
.LP
.B
change_owner(Filename, Uid) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Uid = int()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Changes owner of a file\&. See write_file_info/2\&.
.RE
.LP
.B
change_owner(Filename, Uid, Gid) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Uid = int()
.br
Gid = int()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Changes owner and group of a file\&. See write_file_info/2\&.
.RE
.LP
.B
change_time(Filename, Mtime) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Mtime = time()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Changes the modification and access times of a file\&. See write_file_info/2\&.
.RE
.LP
.B
change_time(Filename, Mtime, Atime) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Mtime = Atime = time()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Changes the modification and last access times of a file\&. See write_file_info/2\&.
.RE
.LP
.B
close(IoDevice) -> ok | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Closes the file referenced by \fIIoDevice\fR\&. It mostly returns \fIok\fR, expect for some severe errors such as out of memory\&.
.LP
Note that if the option \fIdelayed_write\fR was used when opening the file, \fIclose/1\fR might return an old write error and not even try to close the file\&. See open/2\&.
.RE
.LP
.B
consult(Filename) -> {ok, Terms} | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Terms = [term()]
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see below
.br
.RE
.RS
.LP
Reads Erlang terms, separated by \&'\&.\&', from \fIFilename\fR\&. Returns one of the following:
.RS 2
.TP 4
.B
\fI{ok, Terms}\fR:
The file was successfully read\&.
.TP 4
.B
\fI{error, atom()}\fR:
An error occurred when opening the file or reading it\&. See open/2 for a list of typical error codes\&.
.TP 4
.B
\fI{error, {Line, Mod, Term}}\fR:
An error occurred when interpreting the Erlang terms in the file\&. Use \fIformat_error/1\fR to convert the three-element tuple to an English description of the error\&.
.RE
.LP
Example:

.nf
f\&.txt:  {person, "kalle", 25}\&.
        {person, "pelle", 30}\&.
.fi

.nf
1> file:consult("f\&.txt")\&.

{ok,[{person,"kalle",25},{person,"pelle",30}]}
.fi
.RE
.LP
.B
copy(Source, Destination) ->
.br
.B
copy(Source, Destination, ByteCount) -> {ok, BytesCopied} | {error, Reason}
.br
.RS
.TP
Types
Source = Destination = io_device() | Filename | {Filename, Modes}
.br
 Filename = name()
.br
 Modes = [Mode] -- see open/2
.br
ByteCount = int() >= 0 | infinity
.br
BytesCopied = int()
.br
.RE
.RS
.LP
Copies \fIByteCount\fR bytes from \fISource\fR to \fIDestination\fR\&. \fISource\fR and \fIDestination\fR refer to either filenames or IO devices from e\&.g\&. \fIopen/2\fR\&. \fIByteCount\fR defaults \fIinfinity\fR, denoting an infinite number of bytes\&.
.LP
The argument \fIModes\fR is a list of possible modes, see open/2, and defaults to []\&.
.LP
If both \fISource\fR and \fIDestination\fR refer to filenames, the files are opened with \fI[read, binary]\fR and \fI[write, binary]\fR prepended to their mode lists, respectively, to optimize the copy\&.
.LP
If \fISource\fR refers to a filename, it is opened with \fIread\fR mode prepended to the mode list before the copy, and closed when done\&.
.LP
If \fIDestination\fR refers to a filename, it is opened with \fIwrite\fR mode prepended to the mode list before the copy, and closed when done\&.
.LP
Returns \fI{ok, BytesCopied}\fR where \fIBytesCopied\fR is the number of bytes that actually was copied, which may be less than \fIByteCount\fR if end of file was encountered on the source\&. If the operation fails, \fI{error, Reason}\fR is returned\&.
.LP
Typical error reasons: As for \fIopen/2\fR if a file had to be opened, and as for \fIread/2\fR and \fIwrite/2\fR\&.
.RE
.LP
.B
del_dir(Dir) -> ok | {error, Reason}
.br
.RS
.TP
Types
Dir = name()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Tries to delete the directory \fIDir\fR\&. The directory must be empty before it can be deleted\&. Returns \fIok\fR if successful\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing search or write permissions for the parent directories of \fIDir\fR\&.
.TP 4
.B
\fIeexist\fR:
The directory is not empty\&.
.TP 4
.B
\fIenoent\fR:
The directory does not exist\&.
.TP 4
.B
\fIenotdir\fR:
A component of \fIDir\fR is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.TP 4
.B
\fIeinval\fR:
Attempt to delete the current directory\&. On some platforms, \fIeacces\fR is returned instead\&.
.RE
.RE
.LP
.B
delete(Filename) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Tries to delete the file \fIFilename\fR\&. Returns \fIok\fR if successful\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIenoent\fR:
The file does not exist\&.
.TP 4
.B
\fIeacces\fR:
Missing permission for the file or one of its parents\&.
.TP 4
.B
\fIeperm\fR:
The file is a directory and the user is not super-user\&.
.TP 4
.B
\fIenotdir\fR:
A component of the file name is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.TP 4
.B
\fIeinval\fR:
\fIFilename\fR had an improper type, such as tuple\&.
.RE
.SS Warning:
.LP
In a future release, a bad type for the \fIFilename\fR argument will probably generate an exception\&.
.LP


.RE
.LP
.B
eval(Filename) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see below
.br
.RE
.RS
.LP
Reads and evaluates Erlang expressions, separated by \&'\&.\&' (or \&',\&', a sequence of expressions is also an expression), from \fIFilename\fR\&. The actual result of the evaluation is not returned; any expression sequence in the file must be there for its side effect\&. Returns one of the following:
.RS 2
.TP 4
.B
\fIok\fR:
The file was read and evaluated\&.
.TP 4
.B
\fI{error, atom()}\fR:
An error occurred when opening the file or reading it\&. See \fIopen/2\fR for a list of typical error codes\&.
.TP 4
.B
\fI{error, {Line, Mod, Term}}\fR:
An error occurred when interpreting the Erlang expressions in the file\&. Use \fIformat_error/1\fR to convert the three-element tuple to an English description of the error\&.
.RE
.RE
.LP
.B
eval(Filename, Bindings) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Bindings -- see erl_eval(3)
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see eval/1
.br
.RE
.RS
.LP
The same as \fIeval/1\fR but the variable bindings \fIBindings\fR are used in the evaluation\&. See erl_eval(3) about variable bindings\&.
.RE
.LP
.B
file_info(Filename) -> {ok, FileInfo} | {error, Reason}
.br
.RS
.LP
This function is obsolete\&. Use \fIread_file_info/1\fR instead\&.
.RE
.LP
.B
format_error(Reason) -> Chars
.br
.RS
.TP
Types
Reason = atom() | {Line, Mod, Term}
.br
 Line, Mod, Term -- see eval/1
.br
Chars = [char() | Chars]
.br
.RE
.RS
.LP
Given the error reason returned by any function in this module, returns a descriptive string of the error in English\&.
.RE
.LP
.B
get_cwd() -> {ok, Dir} | {error, Reason}
.br
.RS
.TP
Types
Dir = string()
.br
Reason = posix()
.br
.RE
.RS
.LP
Returns \fI{ok, Dir}\fR, where \fIDir\fR is the current working directory of the file server\&.
.SS Note:
.LP
In rare circumstances, this function can fail on Unix\&. It may happen if read permission does not exist for the parent directories of the current directory\&.

.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing read permission for one of the parents of the current directory\&.
.RE
.RE
.LP
.B
get_cwd(Drive) -> {ok, Dir} | {error, Reason}
.br
.RS
.TP
Types
Drive = string() -- see below
.br
Dir = string()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
\fIDrive\fR should be of the form "\fILetter\fR\fI:\fR", for example "c:"\&. Returns \fI{ok, Dir}\fR or \fI{error, Reason}\fR, where \fIDir\fR is the current working directory of the drive specified\&.
.LP
This function returns \fI{error, enotsup}\fR on platforms which have no concept of current drive (Unix, for example)\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIenotsup\fR:
The operating system have no concept of drives\&.
.TP 4
.B
\fIeacces\fR:
The drive does not exist\&.
.TP 4
.B
\fIeinval\fR:
The format of \fIDrive\fR is invalid\&.
.RE
.RE
.LP
.B
list_dir(Dir) -> {ok, Filenames} | {error, Reason}
.br
.RS
.TP
Types
Dir = name()
.br
Filenames = [Filename]
.br
 Filename = string()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Lists all the files in a directory\&. Returns \fI{ok, Filenames}\fR if successful\&. Otherwise, it returns \fI{error, Reason}\fR\&. \fIFilenames\fR is a list of the names of all the files in the directory\&. The names are not sorted\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing search or write permissions for \fIDir\fR or one of its parent directories\&.
.TP 4
.B
\fIenoent\fR:
The directory does not exist\&.
.RE
.RE
.LP
.B
make_dir(Dir) -> ok | {error, Reason}
.br
.RS
.TP
Types
Dir = name()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Tries to create the directory \fIDir\fR\&. Missing parent directories are \fInot\fR created\&. Returns \fIok\fR if successful\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing search or write permissions for the parent directories of \fIDir\fR\&.
.TP 4
.B
\fIeexist\fR:
There is already a file or directory named \fIDir\fR\&.
.TP 4
.B
\fIenoent\fR:
A component of \fIDir\fR does not exist\&.
.TP 4
.B
\fIenospc\fR:
There is a no space left on the device\&.
.TP 4
.B
\fIenotdir\fR:
A component of \fIDir\fR is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.RE
.RE
.LP
.B
make_link(Existing, New) -> ok | {error, Reason}
.br
.RS
.TP
Types
Existing = New = name()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Makes a hard link from \fIExisting\fR to \fINew\fR, on platforms that support links (Unix)\&. This function returns \fIok\fR if the link was successfully created, or \fI{error, Reason}\fR\&. On platforms that do not support links, \fI{error, enotsup}\fR is returned\&.
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing read or write permissions for the parent directories of \fIExisting\fR or \fINew\fR\&.
.TP 4
.B
\fIeexist\fR:
\fINew\fR already exists\&.
.TP 4
.B
\fIenotsup\fR:
Hard links are not supported on this platform\&.
.RE
.RE
.LP
.B
make_symlink(Name1, Name2) -> ok | {error, Reason}
.br
.RS
.TP
Types
Name1 = Name2 = name()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
This function creates a symbolic link \fIName2\fR to the file or directory \fIName1\fR, on platforms that support symbolic links (most Unix systems)\&. \fIName1\fR need not exist\&. This function returns \fIok\fR if the link was successfully created, or \fI{error, Reason}\fR\&. On platforms that do not support symbolic links, \fI{error, enotsup}\fR is returned\&.
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing read or write permissions for the parent directories of \fIName1\fR or \fIName2\fR\&.
.TP 4
.B
\fIeexist\fR:
\fIName2\fR already exists\&.
.TP 4
.B
\fIenotsup\fR:
Symbolic links are not supported on this platform\&.
.RE
.RE
.LP
.B
open(Filename, Modes) -> {ok, IoDevice} | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Modes = [Mode]
.br
 Mode = read | write | append | raw | binary | {delayed_write, Size, Delay} | delayed_write | {read_ahead, Size} | read_ahead | compressed
.br
  Size = Delay = int()
.br
IoDevice = io_device()
.br
Reason = ext_posix() | system_limit
.br
.RE
.RS
.LP
Opens the file \fIFilename\fR in the mode determined by \fIModes\fR, which may contain one or more of the following items:
.RS 2
.TP 4
.B
\fIread\fR:
The file, which must exist, is opened for reading\&.
.TP 4
.B
\fIwrite\fR:
The file is opened for writing\&. It is created if it does not exist\&. If the file exists, and if \fIwrite\fR is not combined with \fIread\fR, the file will be truncated\&.
.TP 4
.B
\fIappend\fR:
The file will be opened for writing, and it will be created if it does not exist\&. Every write operation to a file opened with \fIappend\fR will take place at the end of the file\&.
.TP 4
.B
\fIraw\fR:
The \fIraw\fR option allows faster access to a file, because no Erlang process is needed to handle the file\&. However, a file opened in this way has the following limitations:
.RS 4
.LP

.RS 2
.TP 2
*
The functions in the \fIio\fR module cannot be used, because they can only talk to an Erlang process\&. Instead, use the \fIread/2\fR, \fIread_line/1\fR and \fIwrite/2\fR functions\&.
.TP 2
*
Especially if \fIread_line/1\fR is to be used on a \fIraw\fR file, it is recommended to combine this option with the \fI{read_ahead, Size}\fR option as line oriented I/O is inefficient without buffering\&.
.TP 2
*
Only the Erlang process which opened the file can use it\&.
.TP 2
*
A remote Erlang file server cannot be used; the computer on which the Erlang node is running must have access to the file system (directly or through NFS)\&.
.RE
.RE
.TP 4
.B
\fIbinary\fR:
When this option has been given, read operations on the file will return binaries rather than lists\&.
.TP 4
.B
\fI{delayed_write, Size, Delay}\fR:
If this option is used, the data in subsequent \fIwrite/2\fR calls is buffered until there are at least \fISize\fR bytes buffered, or until the oldest buffered data is \fIDelay\fR milliseconds old\&. Then all buffered data is written in one operating system call\&. The buffered data is also flushed before some other file operation than \fIwrite/2\fR is executed\&.
.RS 4
.LP

.LP
The purpose of this option is to increase performance by reducing the number of operating system calls, so the \fIwrite/2\fR calls should be for sizes significantly less than \fISize\fR, and not interspersed by to many other file operations, for this to happen\&.
.LP

.LP
When this option is used, the result of \fIwrite/2\fR calls may prematurely be reported as successful, and if a write error should actually occur the error is reported as the result of the next file operation, which is not executed\&.
.LP

.LP
For example, when \fIdelayed_write\fR is used, after a number of \fIwrite/2\fR calls, \fIclose/1\fR might return \fI{error, enospc}\fR because there was not enough space on the disc for previously written data, and \fIclose/1\fR should probably be called again since the file is still open\&.
.RE
.TP 4
.B
\fIdelayed_write\fR:
The same as \fI{delayed_write, Size, Delay}\fR with reasonable default values for \fISize\fR and \fIDelay\fR\&. (Roughly some 64 KBytes, 2 seconds)
.TP 4
.B
\fI{read_ahead, Size}\fR:
This option activates read data buffering\&. If \fIread/2\fR calls are for significantly less than \fISize\fR bytes, read operations towards the operating system are still performed for blocks of \fISize\fR bytes\&. The extra data is buffered and returned in subsequent \fIread/2\fR calls, giving a performance gain since the number of operating system calls is reduced\&.
.RS 4
.LP

.LP
The \fIread_ahead\fR buffer is also highly utilized by the \fIread_line/1\fR function in \fIraw\fR mode, why this option is recommended (for performance reasons) when accessing raw files using that function\&.
.LP

.LP
If \fIread/2\fR calls are for sizes not significantly less than, or even greater than \fISize\fR bytes, no performance gain can be expected\&.
.RE
.TP 4
.B
\fIread_ahead\fR:
The same as \fI{read_ahead, Size}\fR with a reasonable default value for \fISize\fR\&. (Roughly some 64 KBytes)
.TP 4
.B
\fIcompressed\fR:
Makes it possible to read or write gzip compressed files\&. The \fIcompressesed\fR option must be combined with either \fIread\fR or \fIwrite\fR, but not both\&. Note that the file size obtained with \fIread_file_info/1\fR will most probably not match the number of bytes that can be read from a compressed file\&.
.TP 4
.B
\fI{encoding, Encoding}\fR:
Makes the file perform automatic translation of characters to and from a specific (Unicode) encoding\&. Note that the data supplied to file:write or returned by file:read still is byte oriented, this option only denotes how data is actually stored in the disk file\&.
.RS 4
.LP

.LP
Depending on the encoding, different methods of reading and writing data is preferred\&. The default encoding of \fIlatin1\fR implies using this (the file) module for reading and writing data, as the interfaces provided here work with byte-oriented data, while using other (Unicode) encodings makes the io(3) module\&'s \fIget_chars\fR, \fIget_line\fR and \fIput_chars\fR functions more suitable, as they can work with the full Unicode range\&.
.LP

.LP
If data is sent to an \fIio_device()\fR in a format that cannot be converted to the specified encoding, or if data is read by a function that returns data in a format that cannot cope with the character range of the data, an error occurs and the file will be closed\&.
.LP

.LP
The allowed values for \fIEncoding\fR are:
.LP

.RS 2
.TP 4
.B
\fIlatin1\fR:
The default encoding\&. Bytes supplied to i\&.e\&. file:write are written as is on the file, likewise bytes read from the file are returned to i\&.e\&. file:read as is\&. If the io(3) module is used for writing, the file can only cope with Unicode characters up to codepoint 255 (the ISO-latin-1 range)\&.
.TP 4
.B
\fIunicode\fR or \fIutf8\fR:
Characters are translated to and from the UTF-8 encoding before being written to or read from the file\&. A file opened in this way might be readable using the file:read function, as long as no data stored on the file lies beyond the ISO-latin-1 range (0\&.\&.255), but failure will occur if the data contains Unicode codepoints beyond that range\&. The file is best read with the functions in the Unicode aware io(3) module\&.
.RS 4
.LP

.LP
Bytes written to the file by any means are translated to UTF-8 encoding before actually being stored on the disk file\&.
.RE
.TP 4
.B
\fIutf16\fR or \fI{utf16, big}\fR:
Works like \fIunicode\fR, but translation is done to and from big endian UTF-16 instead of UTF-8\&.
.TP 4
.B
\fI{utf16, little}\fR:
Works like \fIunicode\fR, but translation is done to and from little endian UTF-16 instead of UTF-8\&.
.TP 4
.B
\fIutf32\fR or \fI{utf32, big}\fR:
Works like \fIunicode\fR, but translation is done to and from big endian UTF-32 instead of UTF-8\&.
.TP 4
.B
\fI{utf32, little}\fR:
Works like \fIunicode\fR, but translation is done to and from little endian UTF-32 instead of UTF-8\&.
.RE
.LP

.LP
The Encoding can be changed for a file "on the fly" by using the io:setopts/2 function, why a file can be analyzed in latin1 encoding for i\&.e\&. a BOM, positioned beyond the BOM and then be set for the right encoding before further reading\&.See the unicode(3) module for functions identifying BOM\&'s\&.
.LP

.LP
This option is not allowed on \fIraw\fR files\&.
.RE
.RE
.LP
Returns:
.RS 2
.TP 4
.B
\fI{ok, IoDevice}\fR:
The file has been opened in the requested mode\&. \fIIoDevice\fR is a reference to the file\&.
.TP 4
.B
\fI{error, Reason}\fR:
The file could not be opened\&.
.RE
.LP
\fIIoDevice\fR is really the pid of the process which handles the file\&. This process is linked to the process which originally opened the file\&. If any process to which the \fIIoDevice\fR is linked terminates, the file will be closed and the process itself will be terminated\&. An \fIIoDevice\fR returned from this call can be used as an argument to the IO functions (see io(3))\&.
.SS Note:
.LP
In previous versions of \fIfile\fR, modes were given as one of the atoms \fIread\fR, \fIwrite\fR, or \fIread_write\fR instead of a list\&. This is still allowed for reasons of backwards compatibility, but should not be used for new code\&. Also note that \fIread_write\fR is not allowed in a mode list\&.

.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIenoent\fR:
The file does not exist\&.
.TP 4
.B
\fIeacces\fR:
Missing permission for reading the file or searching one of the parent directories\&.
.TP 4
.B
\fIeisdir\fR:
The named file is not a regular file\&. It may be a directory, a fifo, or a device\&.
.TP 4
.B
\fIenotdir\fR:
A component of the file name is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.TP 4
.B
\fIenospc\fR:
There is a no space left on the device (if \fIwrite\fR access was specified)\&.
.RE
.RE
.LP
.B
path_consult(Path, Filename) -> {ok, Terms, FullName} | {error, Reason}
.br
.RS
.TP
Types
Path = [Dir]
.br
 Dir = name()
.br
Filename = name()
.br
Terms = [term()]
.br
FullName = string()
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see below
.br
.RE
.RS
.LP
Searches the path \fIPath\fR (a list of directory names) until the file \fIFilename\fR is found\&. If \fIFilename\fR is an absolute filename, \fIPath\fR is ignored\&. Then reads Erlang terms, separated by \&'\&.\&', from the file\&. Returns one of the following:
.RS 2
.TP 4
.B
\fI{ok, Terms, FullName}\fR:
The file was successfully read\&. \fIFullName\fR is the full name of the file\&.
.TP 4
.B
\fI{error, enoent}\fR:
The file could not be found in any of the directories in \fIPath\fR\&.
.TP 4
.B
\fI{error, atom()}\fR:
An error occurred when opening the file or reading it\&. See open/2 for a list of typical error codes\&.
.TP 4
.B
\fI{error, {Line, Mod, Term}}\fR:
An error occurred when interpreting the Erlang terms in the file\&. Use \fIformat_error/1\fR to convert the three-element tuple to an English description of the error\&.
.RE
.RE
.LP
.B
path_eval(Path, Filename) -> {ok, FullName} | {error, Reason}
.br
.RS
.TP
Types
Path = [Dir]
.br
 Dir = name()
.br
Filename = name()
.br
FullName = string()
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see below
.br
.RE
.RS
.LP
Searches the path \fIPath\fR (a list of directory names) until the file \fIFilename\fR is found\&. If \fIFilename\fR is an absolute file name, \fIPath\fR is ignored\&. Then reads and evaluates Erlang expressions, separated by \&'\&.\&' (or \&',\&', a sequence of expressions is also an expression), from the file\&. The actual result of evaluation is not returned; any expression sequence in the file must be there for its side effect\&. Returns one of the following:
.RS 2
.TP 4
.B
\fI{ok, FullName}\fR:
The file was read and evaluated\&. \fIFullName\fR is the full name of the file\&.
.TP 4
.B
\fI{error, enoent}\fR:
The file could not be found in any of the directories in \fIPath\fR\&.
.TP 4
.B
\fI{error, atom()}\fR:
An error occurred when opening the file or reading it\&. See open/2 for a list of typical error codes\&.
.TP 4
.B
\fI{error, {Line, Mod, Term}}\fR:
An error occurred when interpreting the Erlang expressions in the file\&. Use \fIformat_error/1\fR to convert the three-element tuple to an English description of the error\&.
.RE
.RE
.LP
.B
path_open(Path, Filename, Modes) -> {ok, IoDevice, FullName} | {error, Reason}
.br
.RS
.TP
Types
Path = [Dir]
.br
 Dir = name()
.br
Filename = name()
.br
Modes = [Mode] -- see open/2
.br
IoDevice = io_device()
.br
FullName = string()
.br
Reason = ext_posix() | system_limit
.br
.RE
.RS
.LP
Searches the path \fIPath\fR (a list of directory names) until the file \fIFilename\fR is found\&. If \fIFilename\fR is an absolute file name, \fIPath\fR is ignored\&. Then opens the file in the mode determined by \fIModes\fR\&. Returns one of the following:
.RS 2
.TP 4
.B
\fI{ok, IoDevice, FullName}\fR:
The file has been opened in the requested mode\&. \fIIoDevice\fR is a reference to the file and \fIFullName\fR is the full name of the file\&.
.TP 4
.B
\fI{error, enoent}\fR:
The file could not be found in any of the directories in \fIPath\fR\&.
.TP 4
.B
\fI{error, atom()}\fR:
The file could not be opened\&.
.RE
.RE
.LP
.B
path_script(Path, Filename) -> {ok, Value, FullName} | {error, Reason}
.br
.RS
.TP
Types
Path = [Dir]
.br
 Dir = name()
.br
Filename = name()
.br
Value = term()
.br
FullName = string()
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see below
.br
.RE
.RS
.LP
Searches the path \fIPath\fR (a list of directory names) until the file \fIFilename\fR is found\&. If \fIFilename\fR is an absolute file name, \fIPath\fR is ignored\&. Then reads and evaluates Erlang expressions, separated by \&'\&.\&' (or \&',\&', a sequence of expressions is also an expression), from the file\&. Returns one of the following:
.RS 2
.TP 4
.B
\fI{ok, Value, FullName}\fR:
The file was read and evaluated\&. \fIFullName\fR is the full name of the file and \fIValue\fR the value of the last expression\&.
.TP 4
.B
\fI{error, enoent}\fR:
The file could not be found in any of the directories in \fIPath\fR\&.
.TP 4
.B
\fI{error, atom()}\fR:
An error occurred when opening the file or reading it\&. See open/2 for a list of typical error codes\&.
.TP 4
.B
\fI{error, {Line, Mod, Term}}\fR:
An error occurred when interpreting the Erlang expressions in the file\&. Use \fIformat_error/1\fR to convert the three-element tuple to an English description of the error\&.
.RE
.RE
.LP
.B
path_script(Path, Filename, Bindings) -> {ok, Value, FullName} | {error, Reason}
.br
.RS
.TP
Types
Path = [Dir]
.br
 Dir = name()
.br
Filename = name()
.br
Bindings -- see erl_eval(3)
.br
Value = term()
.br
FullName = string()
.br
Reason = posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see path_script/2
.br
.RE
.RS
.LP
The same as \fIpath_script/2\fR but the variable bindings \fIBindings\fR are used in the evaluation\&. See erl_eval(3) about variable bindings\&.
.RE
.LP
.B
pid2name(Pid) -> string() | undefined
.br
.RS
.TP
Types
Pid = pid()
.br
.RE
.RS
.LP
If \fIPid\fR is an IO device, that is, a pid returned from \fIopen/2\fR, this function returns the filename, or rather:
.RS 2
.TP 4
.B
\fI{ok, Filename}\fR:
If this node\&'s file server is not a slave, the file was opened by this node\&'s file server, (this implies that \fIPid\fR must be a local pid) and the file is not closed\&. \fIFilename\fR is the filename in flat string format\&.
.TP 4
.B
\fIundefined\fR:
In all other cases\&.
.RE
.SS Warning:
.LP
This function is intended for debugging only\&.

.RE
.LP
.B
position(IoDevice, Location) -> {ok, NewPosition} | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Location = Offset | {bof, Offset} | {cur, Offset} | {eof, Offset} | bof | cur | eof
.br
 Offset = int()
.br
NewPosition = int()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Sets the position of the file referenced by \fIIoDevice\fR to \fILocation\fR\&. Returns \fI{ok, NewPosition}\fR (as absolute offset) if successful, otherwise \fI{error, Reason}\fR\&. \fILocation\fR is one of the following:
.RS 2
.TP 4
.B
\fIOffset\fR:
The same as \fI{bof, Offset}\fR\&.
.TP 4
.B
\fI{bof, Offset}\fR:
Absolute offset\&.
.TP 4
.B
\fI{cur, Offset}\fR:
Offset from the current position\&.
.TP 4
.B
\fI{eof, Offset}\fR:
Offset from the end of file\&.
.TP 4
.B
\fIbof | cur | eof\fR:
The same as above with \fIOffset\fR 0\&.
.RE
.LP
Note that offsets are counted in bytes, not in characters\&. If the file is opened using some other \fIencoding\fR than \fIlatin1\fR, one byte does not correspond to one character\&. Positioning in such a file can only be done to known character boundaries, i\&.e\&. to a position earlier retrieved by getting a current position, to the beginning/end of the file or to some other position \fIknown\fR to be on a correct character boundary by some other means (typically beyond a byte order mark in the file, which has a known byte-size)\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIeinval\fR:
Either \fILocation\fR was illegal, or it evaluated to a negative offset in the file\&. Note that if the resulting position is a negative value, the result is an error, and after the call the file position is undefined\&.
.RE
.RE
.LP
.B
pread(IoDevice, LocNums) -> {ok, DataL} | eof | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
LocNums = [{Location, Number}]
.br
 Location -- see position/2
.br
 Number = int()
.br
DataL = [Data]
.br
 Data = [char()] | binary()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Performs a sequence of \fIpread/3\fR in one operation, which is more efficient than calling them one at a time\&. Returns \fI{ok, [Data, \&.\&.\&.]}\fR or \fI{error, Reason}\fR, where each \fIData\fR, the result of the corresponding \fIpread\fR, is either a list or a binary depending on the mode of the file, or \fIeof\fR if the requested position was beyond end of file\&.
.LP
As the position is given as a byte-offset, special caution has to be taken when working with files where \fIencoding\fR is set to something else than \fIlatin1\fR, as not every byte position will be a valid character boundary on such a file\&.
.RE
.LP
.B
pread(IoDevice, Location, Number) -> {ok, Data} | eof | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Location -- see position/2
.br
Number = int()
.br
Data = [char()] | binary()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Combines \fIposition/2\fR and \fIread/2\fR in one operation, which is more efficient than calling them one at a time\&. If \fIIoDevice\fR has been opened in raw mode, some restrictions apply: \fILocation\fR is only allowed to be an integer; and the current position of the file is undefined after the operation\&.
.LP
As the position is given as a byte-offset, special caution has to be taken when working with files where \fIencoding\fR is set to something else than \fIlatin1\fR, as not every byte position will be a valid character boundary on such a file\&.
.RE
.LP
.B
pwrite(IoDevice, LocBytes) -> ok | {error, {N, Reason}}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
LocBytes = [{Location, Bytes}]
.br
 Location -- see position/2
.br
 Bytes = iodata()
.br
N = int()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Performs a sequence of \fIpwrite/3\fR in one operation, which is more efficient than calling them one at a time\&. Returns \fIok\fR or \fI{error, {N, Reason}}\fR, where \fIN\fR is the number of successful writes that was done before the failure\&.
.LP
When positioning in a file with other \fIencoding\fR than \fIlatin1\fR, caution must be taken to set the position on a correct character boundary, see position/2 for details\&.
.RE
.LP
.B
pwrite(IoDevice, Location, Bytes) -> ok | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Location -- see position/2
.br
Bytes = iodata()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Combines \fIposition/2\fR and \fIwrite/2\fR in one operation, which is more efficient than calling them one at a time\&. If \fIIoDevice\fR has been opened in raw mode, some restrictions apply: \fILocation\fR is only allowed to be an integer; and the current position of the file is undefined after the operation\&.
.LP
When positioning in a file with other \fIencoding\fR than \fIlatin1\fR, caution must be taken to set the position on a correct character boundary, see position/2 for details\&.
.RE
.LP
.B
read(IoDevice, Number) -> {ok, Data} | eof | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Number = int()
.br
Data = [char()] | binary()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Reads \fINumber\fR bytes/characters from the file referenced by \fIIoDevice\fR\&. The functions \fIread/2\fR, \fIpread/3\fR and \fIread_line/1\fR are the only ways to read from a file opened in raw mode (although they work for normally opened files, too)\&.
.LP
For files where \fIencoding\fR is set to something else than \fIlatin1\fR, one character might be represented by more than one byte on the file\&. The parameter \fINumber\fR always denotes the number of \fIcharacters\fR read from the file, why the position in the file might be moved a lot more than this number when reading a Unicode file\&.
.LP
Also if \fIencoding\fR is set to something else than \fIlatin1\fR, the \fIread/3\fR call will fail if the data contains characters larger than 255, why the io(3) module is to be preferred when reading such a file\&.
.LP
The function returns:
.RS 2
.TP 4
.B
\fI{ok, Data}\fR:
If the file was opened in binary mode, the read bytes are returned in a binary, otherwise in a list\&. The list or binary will be shorter than the number of bytes requested if end of file was reached\&.
.TP 4
.B
\fIeof\fR:
Returned if \fINumber>0\fR and end of file was reached before anything at all could be read\&.
.TP 4
.B
\fI{error, Reason}\fR:
An error occurred\&.
.RE
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIebadf\fR:
The file is not opened for reading\&.
.TP 4
.B
\fI{no_translation, unicode, latin1}\fR:
The file is was opened with another \fIencoding\fR than \fIlatin1\fR and the data on the file can not be translated to the byte-oriented data that this function returns\&.
.RE
.RE
.LP
.B
read_file(Filename) -> {ok, Binary} | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Binary = binary()
.br
Reason = ext_posix() | terminated | system_limit
.br
.RE
.RS
.LP
Returns \fI{ok, Binary}\fR, where \fIBinary\fR is a binary data object that contains the contents of \fIFilename\fR, or \fI{error, Reason}\fR if an error occurs\&.
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIenoent\fR:
The file does not exist\&.
.TP 4
.B
\fIeacces\fR:
Missing permission for reading the file, or for searching one of the parent directories\&.
.TP 4
.B
\fIeisdir\fR:
The named file is a directory\&.
.TP 4
.B
\fIenotdir\fR:
A component of the file name is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.TP 4
.B
\fIenomem\fR:
There is not enough memory for the contents of the file\&.
.RE
.RE
.LP
.B
read_file_info(Filename) -> {ok, FileInfo} | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
FileInfo = #file_info{}
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Retrieves information about a file\&. Returns \fI{ok, FileInfo}\fR if successful, otherwise \fI{error, Reason}\fR\&. \fIFileInfo\fR is a record \fIfile_info\fR, defined in the Kernel include file \fIfile\&.hrl\fR\&. Include the following directive in the module from which the function is called:

.nf
-include_lib("kernel/include/file\&.hrl")\&.
.fi
.LP
The record \fIfile_info\fR contains the following fields\&.
.RS 2
.TP 4
.B
\fIsize = int()\fR:
Size of file in bytes\&.
.TP 4
.B
\fItype = device | directory | regular | other\fR:
The type of the file\&.
.TP 4
.B
\fIaccess = read | write | read_write | none\fR:
The current system access to the file\&.
.TP 4
.B
\fIatime = time()\fR:
The last (local) time the file was read\&.
.TP 4
.B
\fImtime = time()\fR:
The last (local) time the file was written\&.
.TP 4
.B
\fIctime = time()\fR:
The interpretation of this time field depends on the operating system\&. On Unix, it is the last time the file or the inode was changed\&. In Windows, it is the create time\&.
.TP 4
.B
\fImode = int()\fR:
The file permissions as the sum of the following bit values:
.RS 4
.LP

.RS 2
.TP 4
.B
8#00400:
read permission: owner
.TP 4
.B
8#00200:
write permission: owner
.TP 4
.B
8#00100:
execute permission: owner
.TP 4
.B
8#00040:
read permission: group
.TP 4
.B
8#00020:
write permission: group
.TP 4
.B
8#00010:
execute permission: group
.TP 4
.B
8#00004:
read permission: other
.TP 4
.B
8#00002:
write permission: other
.TP 4
.B
8#00001:
execute permission: other
.TP 4
.B
16#800:
set user id on execution
.TP 4
.B
16#400:
set group id on execution
.RE
.LP

.LP
On Unix platforms, other bits than those listed above may be set\&.
.RE
.TP 4
.B
\fIlinks = int()\fR:
Number of links to the file (this will always be 1 for file systems which have no concept of links)\&.
.TP 4
.B
\fImajor_device = int()\fR:
Identifies the file system where the file is located\&. In Windows, the number indicates a drive as follows: 0 means A:, 1 means B:, and so on\&.
.TP 4
.B
\fIminor_device = int()\fR:
Only valid for character devices on Unix\&. In all other cases, this field is zero\&.
.TP 4
.B
\fIinode = int()\fR:
Gives the \fIinode\fR number\&. On non-Unix file systems, this field will be zero\&.
.TP 4
.B
\fIuid = int()\fR:
Indicates the owner of the file\&. Will be zero for non-Unix file systems\&.
.TP 4
.B
\fIgid = int()\fR:
Gives the group that the owner of the file belongs to\&. Will be zero for non-Unix file systems\&.
.RE
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing search permission for one of the parent directories of the file\&.
.TP 4
.B
\fIenoent\fR:
The file does not exist\&.
.TP 4
.B
\fIenotdir\fR:
A component of the file name is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.RE
.RE
.LP
.B
read_line(IoDevice) -> {ok, Data} | eof | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Data = [char()] | binary()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Reads a line of bytes/characters from the file referenced by \fIIoDevice\fR\&. Lines are defined to be delimited by the linefeed (LF, \fI\en\fR) character, but any carriage return (CR, \fI\er\fR) followed by a newline is also treated as a single LF character (the carriage return is silently ignored)\&. The line is returned \fIincluding\fR the LF, but excluding any CR immediately followed by a LF\&. This behaviour is consistent with the behaviour of io:get_line/2\&. If end of file is reached without any LF ending the last line, a line with no trailing LF is returned\&.
.LP
The function can be used on files opened in \fIraw\fR mode\&. It is however inefficient to use it on \fIraw\fR files if the file is not opened with the option \fI{read_ahead, Size}\fR specified, why combining \fIraw\fR and \fI{read_ahead, Size}\fR is highly recommended when opening a text file for raw line oriented reading\&.
.LP
If \fIencoding\fR is set to something else than \fIlatin1\fR, the \fIread_line/1\fR call will fail if the data contains characters larger than 255, why the io(3) module is to be preferred when reading such a file\&.
.LP
The function returns:
.RS 2
.TP 4
.B
\fI{ok, Data}\fR:
One line from the file is returned, including the trailing LF, but with CRLF sequences replaced by a single LF (see above)\&.
.RS 4
.LP

.LP
If the file was opened in binary mode, the read bytes are returned in a binary, otherwise in a list\&.
.RE
.TP 4
.B
\fIeof\fR:
Returned if end of file was reached before anything at all could be read\&.
.TP 4
.B
\fI{error, Reason}\fR:
An error occurred\&.
.RE
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIebadf\fR:
The file is not opened for reading\&.
.TP 4
.B
\fI{no_translation, unicode, latin1}\fR:
The file is was opened with another \fIencoding\fR than \fIlatin1\fR and the data on the file can not be translated to the byte-oriented data that this function returns\&.
.RE
.RE
.LP
.B
read_link(Name) -> {ok, Filename} | {error, Reason}
.br
.RS
.TP
Types
Name = name()
.br
Filename = string()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
This function returns \fI{ok, Filename}\fR if \fIName\fR refers to a symbolic link or \fI{error, Reason}\fR otherwise\&. On platforms that do not support symbolic links, the return value will be \fI{error, enotsup}\fR\&.
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIeinval\fR:
\fILinkname\fR does not refer to a symbolic link\&.
.TP 4
.B
\fIenoent\fR:
The file does not exist\&.
.TP 4
.B
\fIenotsup\fR:
Symbolic links are not supported on this platform\&.
.RE
.RE
.LP
.B
read_link_info(Name) -> {ok, FileInfo} | {error, Reason}
.br
.RS
.TP
Types
Name = name()
.br
FileInfo = #file_info{}, see read_file_info/1
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
This function works like \fIread_file_info/1\fR, except that if \fIName\fR is a symbolic link, information about the link will be returned in the \fIfile_info\fR record and the \fItype\fR field of the record will be set to \fIsymlink\fR\&.
.LP
If \fIName\fR is not a symbolic link, this function returns exactly the same result as \fIread_file_info/1\fR\&. On platforms that do not support symbolic links, this function is always equivalent to \fIread_file_info/1\fR\&.
.RE
.LP
.B
rename(Source, Destination) -> ok | {error, Reason}
.br
.RS
.TP
Types
Source = Destination = name()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Tries to rename the file \fISource\fR to \fIDestination\fR\&. It can be used to move files (and directories) between directories, but it is not sufficient to specify the destination only\&. The destination file name must also be specified\&. For example, if \fIbar\fR is a normal file and \fIfoo\fR and \fIbaz\fR are directories, \fIrename("foo/bar", "baz")\fR returns an error, but \fIrename("foo/bar", "baz/bar")\fR succeeds\&. Returns \fIok\fR if it is successful\&.
.SS Note:
.LP
Renaming of open files is not allowed on most platforms (see \fIeacces\fR below)\&.

.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing read or write permissions for the parent directories of \fISource\fR or \fIDestination\fR\&. On some platforms, this error is given if either \fISource\fR or \fIDestination\fR is open\&.
.TP 4
.B
\fIeexist\fR:
\fIDestination\fR is not an empty directory\&. On some platforms, also given when \fISource\fR and \fIDestination\fR are not of the same type\&.
.TP 4
.B
\fIeinval\fR:
\fISource\fR is a root directory, or \fIDestination\fR is a sub-directory of \fISource\fR\&.
.TP 4
.B
\fIeisdir\fR:
\fIDestination\fR is a directory, but \fISource\fR is not\&.
.TP 4
.B
\fIenoent\fR:
\fISource\fR does not exist\&.
.TP 4
.B
\fIenotdir\fR:
\fISource\fR is a directory, but \fIDestination\fR is not\&.
.TP 4
.B
\fIexdev\fR:
\fISource\fR and \fIDestination\fR are on different file systems\&.
.RE
.RE
.LP
.B
script(Filename) -> {ok, Value} | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Value = term()
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see below
.br
.RE
.RS
.LP
Reads and evaluates Erlang expressions, separated by \&'\&.\&' (or \&',\&', a sequence of expressions is also an expression), from the file\&. Returns one of the following:
.RS 2
.TP 4
.B
\fI{ok, Value}\fR:
The file was read and evaluated\&. \fIValue\fR is the value of the last expression\&.
.TP 4
.B
\fI{error, atom()}\fR:
An error occurred when opening the file or reading it\&. See open/2 for a list of typical error codes\&.
.TP 4
.B
\fI{error, {Line, Mod, Term}}\fR:
An error occurred when interpreting the Erlang expressions in the file\&. Use \fIformat_error/1\fR to convert the three-element tuple to an English description of the error\&.
.RE
.RE
.LP
.B
script(Filename, Bindings) -> {ok, Value} | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Bindings -- see erl_eval(3)
.br
Value = term()
.br
Reason = ext_posix() | terminated | system_limit | {Line, Mod, Term}
.br
 Line, Mod, Term -- see below
.br
.RE
.RS
.LP
The same as \fIscript/1\fR but the variable bindings \fIBindings\fR are used in the evaluation\&. See erl_eval(3) about variable bindings\&.
.RE
.LP
.B
set_cwd(Dir) -> ok | {error,Reason}
.br
.RS
.TP
Types
Dir = name()
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Sets the current working directory of the file server to \fIDir\fR\&. Returns \fIok\fR if successful\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIenoent\fR:
The directory does not exist\&.
.TP 4
.B
\fIenotdir\fR:
A component of \fIDir\fR is not a directory\&. On some platforms, \fIenoent\fR is returned\&.
.TP 4
.B
\fIeacces\fR:
Missing permission for the directory or one of its parents\&.
.TP 4
.B
\fIbadarg\fR:
\fIFilename\fR had an improper type, such as tuple\&.
.RE
.SS Warning:
.LP
In a future release, a bad type for the \fIFilename\fR argument will probably generate an exception\&.
.LP


.RE
.LP
.B
sync(IoDevice) -> ok | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Makes sure that any buffers kept by the operating system (not by the Erlang runtime system) are written to disk\&. On some platforms, this function might have no effect\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIenospc\fR:
Not enough space left to write the file\&.
.RE
.RE
.LP
.B
truncate(IoDevice) -> ok | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Truncates the file referenced by \fIIoDevice\fR at the current position\&. Returns \fIok\fR if successful, otherwise \fI{error, Reason}\fR\&.
.RE
.LP
.B
write(IoDevice, Bytes) -> ok | {error, Reason}
.br
.RS
.TP
Types
IoDevice = io_device()
.br
Bytes = iodata()
.br
Reason = ext_posix() | terminated
.br
.RE
.RS
.LP
Writes \fIBytes\fR to the file referenced by \fIIoDevice\fR\&. This function is the only way to write to a file opened in raw mode (although it works for normally opened files, too)\&. Returns \fIok\fR if successful, and \fI{error, Reason}\fR otherwise\&.
.LP
If the file is opened with \fIencoding\fR set to something else than \fIlatin1\fR, each byte written might result in several bytes actually being written to the file, as the byte range 0\&.\&.255 might represent anything between one and four bytes depending on value and UTF encoding type\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIebadf\fR:
The file is not opened for writing\&.
.TP 4
.B
\fIenospc\fR:
There is a no space left on the device\&.
.RE
.RE
.LP
.B
write_file(Filename, Bytes) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Bytes = iodata()
.br
Reason = ext_posix() | terminated | system_limit
.br
.RE
.RS
.LP
Writes the contents of the iodata term \fIBytes\fR to the file \fIFilename\fR\&. The file is created if it does not exist\&. If it exists, the previous contents are overwritten\&. Returns \fIok\fR, or \fI{error, Reason}\fR\&.
.LP
Typical error reasons are:
.RS 2
.TP 4
.B
\fIenoent\fR:
A component of the file name does not exist\&.
.TP 4
.B
\fIenotdir\fR:
A component of the file name is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.TP 4
.B
\fIenospc\fR:
There is a no space left on the device\&.
.TP 4
.B
\fIeacces\fR:
Missing permission for writing the file or searching one of the parent directories\&.
.TP 4
.B
\fIeisdir\fR:
The named file is a directory\&.
.RE
.RE
.LP
.B
write_file(Filename, Bytes, Modes) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
Bytes = iodata()
.br
Modes = [Mode] -- see open/2
.br
Reason = ext_posix() | terminated | system_limit
.br
.RE
.RS
.LP
Same as \fIwrite_file/2\fR, but takes a third argument \fIModes\fR, a list of possible modes, see open/2\&. The mode flags \fIbinary\fR and \fIwrite\fR are implicit, so they should not be used\&.
.RE
.LP
.B
write_file_info(Filename, FileInfo) -> ok | {error, Reason}
.br
.RS
.TP
Types
Filename = name()
.br
FileInfo = #file_info{} -- see also read_file_info/1
.br
Reason = ext_posix()
.br
.RE
.RS
.LP
Change file information\&. Returns \fIok\fR if successful, otherwise \fI{error, Reason}\fR\&. \fIFileInfo\fR is a record \fIfile_info\fR, defined in the Kernel include file \fIfile\&.hrl\fR\&. Include the following directive in the module from which the function is called:

.nf
-include_lib("kernel/include/file\&.hrl")\&.
.fi
.LP
The following fields are used from the record, if they are given\&.
.RS 2
.TP 4
.B
\fIatime = time()\fR:
The last (local) time the file was read\&.
.TP 4
.B
\fImtime = time()\fR:
The last (local) time the file was written\&.
.TP 4
.B
\fIctime = time()\fR:
On Unix, any value give for this field will be ignored (the "ctime" for the file will be set to the current time)\&. On Windows, this field is the new creation time to set for the file\&.
.TP 4
.B
\fImode = int()\fR:
The file permissions as the sum of the following bit values:
.RS 4
.LP

.RS 2
.TP 4
.B
8#00400:
read permission: owner
.TP 4
.B
8#00200:
write permission: owner
.TP 4
.B
8#00100:
execute permission: owner
.TP 4
.B
8#00040:
read permission: group
.TP 4
.B
8#00020:
write permission: group
.TP 4
.B
8#00010:
execute permission: group
.TP 4
.B
8#00004:
read permission: other
.TP 4
.B
8#00002:
write permission: other
.TP 4
.B
8#00001:
execute permission: other
.TP 4
.B
16#800:
set user id on execution
.TP 4
.B
16#400:
set group id on execution
.RE
.LP

.LP
On Unix platforms, other bits than those listed above may be set\&.
.RE
.TP 4
.B
\fIuid = int()\fR:
Indicates the owner of the file\&. Ignored for non-Unix file systems\&.
.TP 4
.B
\fIgid = int()\fR:
Gives the group that the owner of the file belongs to\&. Ignored non-Unix file systems\&.
.RE
.LP
Typical error reasons:
.RS 2
.TP 4
.B
\fIeacces\fR:
Missing search permission for one of the parent directories of the file\&.
.TP 4
.B
\fIenoent\fR:
The file does not exist\&.
.TP 4
.B
\fIenotdir\fR:
A component of the file name is not a directory\&. On some platforms, \fIenoent\fR is returned instead\&.
.RE
.RE
.SH POSIX ERROR CODES
.RS 2
.TP 2
*
\fIeacces\fR - permission denied
.TP 2
*
\fIeagain\fR - resource temporarily unavailable
.TP 2
*
\fIebadf\fR - bad file number
.TP 2
*
\fIebusy\fR - file busy
.TP 2
*
\fIedquot\fR - disk quota exceeded
.TP 2
*
\fIeexist\fR - file already exists
.TP 2
*
\fIefault\fR - bad address in system call argument
.TP 2
*
\fIefbig\fR - file too large
.TP 2
*
\fIeintr\fR - interrupted system call
.TP 2
*
\fIeinval\fR - invalid argument
.TP 2
*
\fIeio\fR - IO error
.TP 2
*
\fIeisdir\fR - illegal operation on a directory
.TP 2
*
\fIeloop\fR - too many levels of symbolic links
.TP 2
*
\fIemfile\fR - too many open files
.TP 2
*
\fIemlink\fR - too many links
.TP 2
*
\fIenametoolong\fR - file name too long
.TP 2
*
\fIenfile\fR - file table overflow
.TP 2
*
\fIenodev\fR - no such device
.TP 2
*
\fIenoent\fR - no such file or directory
.TP 2
*
\fIenomem\fR - not enough memory
.TP 2
*
\fIenospc\fR - no space left on device
.TP 2
*
\fIenotblk\fR - block device required
.TP 2
*
\fIenotdir\fR - not a directory
.TP 2
*
\fIenotsup\fR - operation not supported
.TP 2
*
\fIenxio\fR - no such device or address
.TP 2
*
\fIeperm\fR - not owner
.TP 2
*
\fIepipe\fR - broken pipe
.TP 2
*
\fIerofs\fR - read-only file system
.TP 2
*
\fIespipe\fR - invalid seek
.TP 2
*
\fIesrch\fR - no such process
.TP 2
*
\fIestale\fR - stale remote file handle
.TP 2
*
\fIexdev\fR - cross-domain link
.RE
.SH PERFORMANCE
.LP
Some operating system file operations, for example a \fIsync/1\fR or \fIclose/1\fR on a huge file, may block their calling thread for seconds\&. If this befalls the emulator main thread, the response time is no longer in the order of milliseconds, depending on the definition of "soft" in soft real-time system\&.
.LP
If the device driver thread pool is active, file operations are done through those threads instead, so the emulator can go on executing Erlang processes\&. Unfortunately, the time for serving a file operation increases due to the extra scheduling required from the operating system\&.
.LP
If the device driver thread pool is disabled or of size 0, large file reads and writes are segmented into several smaller, which enables the emulator so server other processes during the file operation\&. This gives the same effect as when using the thread pool, but with larger overhead\&. Other file operations, for example \fIsync/1\fR or \fIclose/1\fR on a huge file, still are a problem\&.
.LP
For increased performance, raw files are recommended\&. Raw files uses the file system of the node\&'s host machine\&. For normal files (non-raw), the file server is used to find the files, and if the node is running its file server as slave to another node\&'s, and the other node runs on some other host machine, they may have different file systems\&. This is seldom a problem, but you have now been warned\&.
.LP
A normal file is really a process so it can be used as an IO device (see \fIio\fR)\&. Therefore when data is written to a normal file, the sending of the data to the file process, copies all data that are not binaries\&. Opening the file in binary mode and writing binaries is therefore recommended\&. If the file is opened on another node, or if the file server runs as slave to another node\&'s, also binaries are copied\&.
.LP
Caching data to reduce the number of file operations, or rather the number of calls to the file driver, will generally increase performance\&. The following function writes 4 MBytes in 23 seconds when tested:

.nf
create_file_slow(Name, N) when integer(N), N >= 0 ->
    {ok, FD} = file:open(Name, [raw, write, delayed_write, binary]),
    ok = create_file_slow(FD, 0, N),
    ok = ?FILE_MODULE:close(FD),
    ok\&.
      
create_file_slow(FD, M, M) ->
    ok;
create_file_slow(FD, M, N) ->
    ok = file:write(FD, <<M:32/unsigned>>),
    create_file_slow(FD, M+1, N)\&.
.fi
.LP
The following, functionally equivalent, function collects 1024 entries into a list of 128 32-byte binaries before each call to \fIfile:write/2\fR and so does the same work in 0\&.52 seconds, which is 44 times faster\&.

.nf
create_file(Name, N) when integer(N), N >= 0 ->
    {ok, FD} = file:open(Name, [raw, write, delayed_write, binary]),
    ok = create_file(FD, 0, N),
    ok = ?FILE_MODULE:close(FD),
    ok\&.
      
create_file(FD, M, M) ->
    ok;
create_file(FD, M, N) when M + 1024 =&lt; N ->
    create_file(FD, M, M + 1024, []),
    create_file(FD, M + 1024, N);
create_file(FD, M, N) ->
    create_file(FD, M, N, [])\&.
      
create_file(FD, M, M, R) ->
    ok = file:write(FD, R);
create_file(FD, M, N0, R) when M + 8 =&lt; N0 ->
    N1  = N0-1,  N2  = N0-2,  N3  = N0-3,  N4  = N0-4, 
    N5  = N0-5,  N6  = N0-6,  N7  = N0-7,  N8  = N0-8, 
    create_file(FD, M, N8, 
                [<<N8:32/unsigned,  N7:32/unsigned, 
                   N6:32/unsigned,  N5:32/unsigned, 
                   N4:32/unsigned,  N3:32/unsigned, 
                   N2:32/unsigned,  N1:32/unsigned>> | R]);
create_file(FD, M, N0, R) ->
    N1 = N0-1,
    create_file(FD, M, N1, [<<N1:32/unsigned>> | R])\&.
.fi
.SS Note:
.LP
Trust only your own benchmarks\&. If the list length in \fIcreate_file/2\fR above is increased, it will run slightly faster, but consume more memory and cause more memory fragmentation\&. How much this affects your application is something that this simple benchmark can not predict\&.
.LP
If the size of each binary is increased to 64 bytes, it will also run slightly faster, but the code will be twice as clumsy\&. In the current implementation are binaries larger than 64 bytes stored in memory common to all processes and not copied when sent between processes, while these smaller binaries are stored on the process heap and copied when sent like any other term\&.
.LP
So, with a binary size of 68 bytes \fIcreate_file/2\fR runs 30 percent slower then with 64 bytes, and will cause much more memory fragmentation\&. Note that if the binaries were to be sent between processes (for example a non-raw file) the results would probably be completely different\&.

.LP
A raw file is really a port\&. When writing data to a port, it is efficient to write a list of binaries\&. There is no need to flatten a deep list before writing\&. On Unix hosts, scatter output, which writes a set of buffers in one operation, is used when possible\&. In this way \fIfile:write(FD, [Bin1, Bin2 | Bin3])\fR will write the contents of the binaries without copying the data at all except for perhaps deep down in the operating system kernel\&.
.LP
For raw files, \fIpwrite/2\fR and \fIpread/2\fR are efficiently implemented\&. The file driver is called only once for the whole operation, and the list iteration is done in the file driver\&.
.LP
The options \fIdelayed_write\fR and \fIread_ahead\fR to \fIfile:open/2\fR makes the file driver cache data to reduce the number of operating system calls\&. The function \fIcreate_file/2\fR in the example above takes 60 seconds seconds without the \fIdelayed_write\fR option, which is 2\&.6 times slower\&.
.LP
And, as a really bad example, \fIcreate_file_slow/2\fR above without the \fIraw\fR, \fIbinary\fR and \fIdelayed_write\fR options, that is it calls \fIfile:open(Name, [write])\fR, needs 1 min 20 seconds for the job, which is 3\&.5 times slower than the first example, and 150 times slower than the optimized \fIcreate_file/2\fR\&. 
.SH WARNINGS
.LP
If an error occurs when accessing an open file with the \fIio\fR module, the process which handles the file will exit\&. The dead file process might hang if a process tries to access it later\&. This will be fixed in a future release\&.
.SH SEE ALSO
.LP
filename(3)
